#include <bits/stdc++.h>
using namespace std;
//#define int long long

struct city {
    vector<int> road;
};

struct warden {
    int p, h;
};

void bfs(int v, vector<city>& c, int len, vector<bool>&  is_guarded, int n) {

    vector<bool> visited(n + 1);
    queue<int> q;
    is_guarded[v] = 1;
    visited[v] = 1;
    q.push(v);

    int cnt = 1;
    while (!q.empty()) {
        if (cnt > len) return;
        int val = q.front();
        visited[val] = 1;
        q.pop();
        for (auto i : c[val].road) {
            if (!visited[i]) {
                q.push(i);
                is_guarded[i] = 1;
            }
        }
        cnt++;
    }

}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int n, m, k;
    cin >> n >> m >> k;

    vector<city> c(n + 1);

    for (int i = 0; i < m; i++) {
        int a, b;
        cin >> a >> b;
        c[a].road.push_back(b);
        c[b].road.push_back(a);
    }

    vector<int> w(n + 1); // индекс - № склада p, элемент - h
    queue <int> q; // номера складов
    vector<bool> is_guarded(n + 1);

    for (int i = 0; i < k; i++) {
        int p, h;
        cin >> p >> h;
        w[p] = h;
        q.push(p);
    }

    while (!q.empty()) {
        //cout << "proccesing...\n";
        int v = q.front();
        q.pop();
        int len = w[v];
        bfs(v, c, len, is_guarded, n);
    }

    vector<int> ans;
    for (int i = 0; i < is_guarded.size(); i++) {
        if (is_guarded[i]) {
            ans.push_back(i);
        }
    }

    if (ans.size() == 0) {
        return 0;
    }

    cout << ans.size() << "\n";
    for (auto i : ans) cout << i << " ";
}
